(module vigraplt scheme
  (provide 
           ;path
           vigraplt-path
   
           ;vigraplt.helpers:
           
           ;images
           make-image
           image-data
           image-width
           image-height
           image-ref
           image-set!
           copy-image
           image->list
           list->image
           image-map
           image-map!
           image-for-each-index
           image-reduce
           
           ;matrices
           make-matrix
           matrix-data
           matrix-rows
           matrix-cols
           matrix-ref
           matrix-set!
           copy-matrix
           matrix->list
           list->matrix
           matrix-mult
           
           ;vigraplt.impex
           loadimage
           saveimage
           
           ;;vigraplt.filters
           gsmooth
           ggradient
           laplacianofgaussian
           gsharpening
           sharpening
           nonlineardiffusion
           distancetransform
           
           ;;vigraplt.imgproc
           resizeimage
           rotateimage
           affinewarpimage
           reflectimage
           fouriertransform
           
           ;;vigraplt.segmentation
           labelimage
           watersheds
           cannyedgeimage
           differenceofexponentialedgeimage
           regionimagetocrackedgeimage
           
           ;;vigraplt.morphology
           erodeimage
           dilateimage
           openingimage
           closingimage
           
           ;vigraplt.viewer
           show-image
           )
  
 
  (require scheme/foreign)
  (unsafe!)

  (define vigraplt-path (collection-path "vigraplt"))

  ;Load dll under windows, dylib under MacOS
  (define dylib-path
    (cond ((equal? (system-type 'os) 'windows) (build-path vigraplt-path "vigra_c.dll"))
          ((equal? (system-type 'os) 'macosx)  (build-path vigraplt-path "vigra_c.dylib"))
          (else (error "Only macosx or windows are supported"))))
    	    

  (include "vigraplt.carray.ss")
  (include "vigraplt.helpers.ss")
  (include "vigraplt.impex.ss")
  (include "vigraplt.filters.ss")
  (include "vigraplt.imgproc.ss")
  (include "vigraplt.segmentation.ss")
  (include "vigraplt.morphology.ss")
  (include "vigraplt.viewer.ss")

)

